## lua-curl 0.2.0

=== Makefile ===
# TODO: support for abi&libtool, installation of lua-curl.h

LIBNAME=liblua5.1-curl
LIBTOOL=libtool --silent --tag=CC
HEADER=/usr/include/curl/curl.h
PREFIX=/usr/local/
#LUA=lua50
LUA=lua5.1
LUADOC= luadoc
VERSION_INFO=0:0:0

CONSTANTS:= curlopt.h curl_netrcopt.h curl_form.h curl_authopt.h 
CURL_CFLAGS:= $(shell curl-config --cflags 2>/dev/null)
CURL_LDFLAGS:= $(shell curl-config --libs 2>/dev/null)
REALSO:=$(LIBNAME).so.$(subst :,.,$(VERSION_INFO))

# ------------------------------ lua5.1 stuff ---------------------------------
ifeq "$(LUA)" "lua5.1"
LUA_CFLAGS := $(shell pkg-config lua5.1 --cflags)
# This retrieves the name of the libtool convenience library for Lua
# (e.g. "/usr/lib/liblua5.1.la") used by --mode=link.
LUA_LIBTOOL_S := $(shell pkg-config lua5.1 --variable=libtool_lib)
LUA_LIBTOOL_D := $(LUA_LIBTOOL_S)
# this is the path where you'll eventually install the module
LUA_RPATH:=$(shell pkg-config lua5.1 --define-variable=prefix=$(PREFIX) \
	--variable=INSTALL_CMOD)
# this is the path where you'll eventually install the C header file
LUA_HPATH:=$(shell pkg-config lua5.1 --define-variable=prefix=$(PREFIX) \
	--variable=includedir)/lua5.1
LUA_DPATH:=$(PREFIX)/share/doc/luacurl/
LUA_LPATH:=$(PREFIX)/lib/
OBJS:= lua-curl.lo luabind.lo
endif

# ------------------------------ lua50 stuff ---------------------------------
ifeq "$(LUA)" "lua50"
LUA_CFLAGS := $(shell pkg-config lua50 --cflags) 
LUA_LIBTOOL_D := $(shell pkg-config lualib50 --libs)
LUA_LIBTOOL_S := -llua50 -llualib50
LUA_RPATH:= $(PREFIX)/lib/lua/50/
LUA_HPATH:=$(PREFIX)/include/lua50/
LUA_DPATH:=$(PREFIX)/share/doc/luacurl/
LUA_LPATH:=$(PREFIX)/lib/
#compat-5.1.[ch] are not provided in this package
OBJS:= lua-curl.lo luabind.lo compat-5.1.lo
endif

# ------------------------- Here the Makefile --------------------------------
all: $(LIBNAME).la
constants:$(CONSTANTS)
doc: doc/curl.html
doc/curl.html: lua-curl.luadoc
	cp lua-curl.luadoc doc/curl.lua
	$(LUADOC) -d `pwd`/doc/ `pwd`/doc/*.lua
	rm -f doc/*.lua doc/index.html

%.lo: %.c
	$(LIBTOOL) --mode=compile $(CC) -c -Wall -O2 $(LUA_CFLAGS) $<

# link objects to make static and dynamic libraries.  The .so will be
# left in "./.libs/".  Note that the Lua library and its dependencies are
# not called out on the link line since they are assumed to be part of
# whatever our library is linked to.  We want to avoid duplicate library
# copies, which is a waste of space and can cause run-time problems.
$(LIBNAME).la curl.so: constants $(OBJS)
	$(LIBTOOL) --mode=link $(CC) \
		-rpath $(LUA_RPATH) -o $(LIBNAME).la \
		-version-info $(VERSION_INFO) \
		$(CURL_LDFLAGS) $(OBJS)
	ln -sf ./.libs/$(REALSO) curl.so

# If all went well, we can dynamically load the module into Lua.  The
# following will load the library into the interpreter and call a function.
test: curl.so
	@echo "************************* lua dynamic ***************************"
	$(LUA) -l curl test.lua
	@echo "*****************************************************************"

# install static and dynamic libraries for module to global location
install: $(LIBNAME).la
	mkdir -p $(LUA_RPATH)
	mkdir -p $(LUA_LPATH)
	$(LIBTOOL) --mode=install install $(LIBNAME).la \
		$(LUA_LPATH)/$(LIBNAME).la
	$(LIBTOOL) --finish $(LUA_LPATH)
	cd $(LUA_RPATH);\
		ln -s /$(subst $(DESTDIR),,$(LUA_LPATH))/$(REALSO) curl.so
	mkdir -p $(LUA_HPATH)
	$(LIBTOOL) --mode=install install lua-curl.h $(LUA_HPATH)/lua-curl.h
	mkdir -p $(LUA_DPATH)
	$(LIBTOOL) --mode=install install doc/curl.html $(LUA_DPATH)/curl.html

clean:
	$(RM) -f *.o *.lo *.la *.so app doc/index.html doc/*.lua
	$(RM) -rf ./.libs/
	$(RM) -f $(CONSTANTS) static-stamp dynamic-stamp

dist: clean
	DIR=`basename $$PWD`;\
		cd ..;\
		tar -cvzf $$DIR.tar.gz -X $$DIR/exclude-dist $$DIR

# Constants genereated starting from the cURL headers:

curlopt.h: $(HEADER)
	$(H)cat $(HEADER) | grep "^ *CINIT(" | sed "s/CINIT(/{\"OPT_/" | \
		tr -s "  " " " | sed "s/, /\",CURLOPTTYPE_/" | \
		sed "s/, / + /" | sed "s/),/},/" > curlopt.h

curl_netrcopt.h:$(HEADER)
	$(H)cat $(HEADER) | grep "^ *CURL_NETRC_[A-Z]*," | \
		sed 's/^ *CURL_\(NETRC_[A-Z]*\),.*$$/{"\1", (int)CURL_\1},/' \
		> curl_netrcopt.h

curl_authopt.h:$(HEADER)
	$(H)cat $(HEADER) | grep "CURLAUTH_" | \
		sed "s/#define *CURL/{\"/" | sed "s/ *\/\*.*\*\///" | \
		sed "s/ /\",/" | sed "s/$$/},/" > curl_authopt.h

curl_form.h: $(HEADER)
	$(H)cat $(HEADER) | grep "^ *CFINIT" | grep -v "CFINIT(NOTHING)" | \
		sed 's/^ *CFINIT(\([^)]*\)),.*$$/{"FORM_\1",CURLFORM_\1},/' \
		> curl_form.h

# eof

## lua-curl 0.3.0

=== Makefile ===
--- 
+++ 
@@ -9,14 +9,15 @@
 LUADOC= luadoc
 VERSION_INFO=0:0:0
 
-CONSTANTS:= curlopt.h curl_netrcopt.h curl_form.h curl_authopt.h 
-CURL_CFLAGS:= $(shell curl-config --cflags 2>/dev/null)
+CONSTANTS:= curlopt.h curl_netrcopt.h \
+	curl_form.h curl_authopt.h curl_ftpauthopt.h curl_ftpmethods.h
+CURL_CFLAGS:= $(shell curl-config --cflags 2>/dev/null) $(shell getconf LFS_CFLAGS)
 CURL_LDFLAGS:= $(shell curl-config --libs 2>/dev/null)
 REALSO:=$(LIBNAME).so.$(subst :,.,$(VERSION_INFO))
 
 # ------------------------------ lua5.1 stuff ---------------------------------
 ifeq "$(LUA)" "lua5.1"
-LUA_CFLAGS := $(shell pkg-config lua5.1 --cflags)
+LUA_CFLAGS := $(shell pkg-config lua5.1 --cflags) $(shell getconf LFS_CFLAGS)
 # This retrieves the name of the libtool convenience library for Lua
 # (e.g. "/usr/lib/liblua5.1.la") used by --mode=link.
 LUA_LIBTOOL_S := $(shell pkg-config lua5.1 --variable=libtool_lib)
@@ -94,11 +95,16 @@
 	$(RM) -f *.o *.lo *.la *.so app doc/index.html doc/*.lua
 	$(RM) -rf ./.libs/
 	$(RM) -f $(CONSTANTS) static-stamp dynamic-stamp
+	$(RM) -rf win32-*
 
 dist: clean
 	DIR=`basename $$PWD`;\
+	VERSION=`grep LUACURL_VERSION version.h|cut -d \" -f 2`;\
 		cd ..;\
-		tar -cvzf $$DIR.tar.gz -X $$DIR/exclude-dist $$DIR
+		cp -r $$DIR lua-curl-$$VERSION; \
+		tar -cvzf lua-curl_$$VERSION.orig.tar.gz \
+		-X $$DIR/exclude-dist lua-curl-$$VERSION;\
+		rm -rf lua-curl-$$VERSION
 
 # Constants genereated starting from the cURL headers:
 
@@ -117,9 +123,61 @@
 		sed "s/#define *CURL/{\"/" | sed "s/ *\/\*.*\*\///" | \
 		sed "s/ /\",/" | sed "s/$$/},/" > curl_authopt.h
 
+curl_ftpauthopt.h:$(HEADER)
+	$(H)cat /usr/include/curl/curl.h | grep -B10 '} curl_ftpauth' | \
+		grep "CURLFTPAUTH_" | \
+		grep -v "LAST.*never use" | \
+		sed "s/^ *CURL//" | sed "s/^\([^,]*\),.*$$/{\"\1\",CURL\1},/" \
+		> curl_ftpauthopt.h
+
+curl_ftpmethods.h:$(HEADER)
+	$(H)cat /usr/include/curl/curl.h | grep -B10 '} curl_ftpmethod' | \
+		grep "CURLFTPMETHOD_" | \
+		grep -v "LAST.*never use" | \
+		sed "s/^ *CURL//" | sed "s/^\([^,]*\),.*$$/{\"\1\",CURL\1},/" \
+		> curl_ftpmethods.h
+
 curl_form.h: $(HEADER)
 	$(H)cat $(HEADER) | grep "^ *CFINIT" | grep -v "CFINIT(NOTHING)" | \
 		sed 's/^ *CFINIT(\([^)]*\)),.*$$/{"FORM_\1",CURLFORM_\1},/' \
 		> curl_form.h
 
+# win32 stuff
+
+.PHONY: win32-openssl
+
+win32-openssl:
+	make clean
+	make constants HEADER=/usr/i586-mingw32msvc/include/curl/curl.h
+	mkdir -p win32-openssl
+	cd win32-openssl; unzip ../lua5_1_4_Win32_dll8_lib.zip
+	cd win32-openssl; rm *.dll *.lib
+	cd win32-openssl; unzip ../lua5_1_4_Win32_bin.zip
+	i586-mingw32msvc-gcc \
+		-I win32-openssl/include/ \
+		-I . -I /usr/i586-mingw32msvc/include/ \
+		-c lua-curl.c -o win32-openssl/lua-curl.o 
+	i586-mingw32msvc-gcc -I . \
+		-I win32-openssl/include/ \
+		-I /usr/i586-mingw32msvc/include/ \
+		-c luabind.c -o win32-openssl/luabind.o 
+	i586-mingw32msvc-dlltool -e win32-openssl/exports.o -l win32-openssl/lua-curl.lib win32-openssl/*.o
+	i586-mingw32msvc-gcc win32-openssl/*.o \
+		-o win32-openssl/curl.dll -shared \
+		-L /usr/i586-mingw32msvc/bin/ \
+		win32-openssl/lua5.1.dll \
+		-lcurl-4
+	for X in libcurl-4 libz; do\
+		cp /usr/i586-mingw32msvc/bin/$$X.dll win32-openssl;\
+	done
+	cp test.lua win32-openssl
+	rm -rf win32-openssl/*.o win32-openssl/include/ \
+		win32-openssl/*.lib win32-openssl/lua51.dll
+	i586-mingw32msvc-strip win32-openssl/*.dll
+	cp -r win32-openssl freepops-lua-curl-binary-win32-openssl
+	zip -r freepops-lua-curl-binary-win32-openssl.zip freepops-lua-curl-binary-win32-openssl
+	rm -rf freepops-lua-curl-binary-win32-openssl
+	mv freepops-lua-curl-binary-win32-openssl.zip ..
+
+
 # eof

=== debian/changelog ===
lua-curl (0.3.0-13) unstable; urgency=medium

  * QA upload.
  * Fix FTBFS with new curl. (Closes: #1114192)

 -- Adrian Bunk <bunk@debian.org>  Tue, 07 Oct 2025 17:45:36 +0300

lua-curl (0.3.0-12) unstable; urgency=medium

  * QA upload.
  * Drop non-existing Homepage.
  * Move Vcs to salsa.

 -- Bastian Germann <bage@debian.org>  Fri, 17 Feb 2023 00:22:39 +0100

lua-curl (0.3.0-11) unstable; urgency=medium

  * QA upload.
  * Fix empty curl_ftpauthopt.h and curl_ftpmethods.h due to
    multiarch location of curl.h.
  * Fix curl.h parsing to fix empty curlopt.h. (Closes: #1026097)

 -- Adrian Bunk <bunk@debian.org>  Fri, 27 Jan 2023 20:48:20 +0200

lua-curl (0.3.0-10) unstable; urgency=medium

  * QA upload.
  * Set maintainer to Debian QA Group <packages@qa.debian.org>. (see: #995507)

 -- Marcos Talau <talau@debian.org>  Tue, 15 Nov 2022 07:37:09 -0300

lua-curl (0.3.0-9.2) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/control: Drop explicit Pre-Depends on multiarch-support
    (Closes: #870549).

 -- Aurelien Jarno <aurel32@debian.org>  Sat, 20 Jan 2018 21:17:08 +0100

lua-curl (0.3.0-9.1) unstable; urgency=medium

  * Non-maintainer upload.
  * curl headers are now in the multiarch include form, use them.
    (Closes: #852044)

 -- Daniel Silverstone <dsilvers@digital-scurf.org>  Sat, 28 Jan 2017 14:09:19 +0000

lua-curl (0.3.0-9) unstable; urgency=medium

  * Fix FTBFS (Closes: #755338) 

 -- Enrico Tassi <gareuselesinge@debian.org>  Wed, 27 Aug 2014 11:10:17 +0200

lua-curl (0.3.0-8) unstable; urgency=medium

  * Ported to Lua 5.2 (thanks Igor Bogomazov) (Closes: #746213)
  * Remove transitional packages

 -- Enrico Tassi <gareuselesinge@debian.org>  Sun, 11 May 2014 17:13:22 +0200

lua-curl (0.3.0-7) unstable; urgency=low

  * Fix Makefile to generate curl_authopt.h in a proper way 

 -- Enrico Tassi <gareuselesinge@debian.org>  Thu, 10 May 2012 10:52:01 +0200

lua-curl (0.3.0-6) unstable; urgency=low

  * Switch to dh-lua
  * Packages renamed according to the new Lua policy
  * bumped standards-version to 3.9.3, no changes
  * debian/compat set to 8
  * Copyright format 1.0 

 -- Enrico Tassi <gareuselesinge@debian.org>  Thu, 10 May 2012 10:43:44 +0200

lua-curl (0.3.0-5) unstable; urgency=low

  * buped standards-version to 3.9.2, no change needed 
  * multi-arch compliant (dh >= 8.1.3, lua5.1-policy >= 32)

 -- Enrico Tassi <gareuselesinge@debian.org>  Wed, 20 Jul 2011 22:28:09 +0200

lua-curl (0.3.0-4) unstable; urgency=low

  * source format 3.0 quilt
  * add make.patch to fix compilation with recent curl headers
  * buped standards-version to 3.9.1, depend on liblua5.1-policy-dev >= 27

 -- Enrico Tassi <gareuselesinge@debian.org>  Sun, 20 Feb 2011 14:45:06 +0100

lua-curl (0.3.0-3) unstable; urgency=low

  * changed lua to Lua 
  * build-depend on lua5.1-policy-dev >= 22
  * buped standards-version to 3.8.2, no change needed 

 -- Enrico Tassi <gareuselesinge@debian.org>  Tue, 21 Jul 2009 15:46:58 +0200

lua-curl (0.3.0-2) unstable; urgency=low

  * upload to unstable
  * standards version bumped to 3.8.1, no changes needed

 -- Enrico Tassi <gareuselesinge@debian.org>  Sun, 15 Mar 2009 10:08:46 +0100

lua-curl (0.3.0-1) experimental; urgency=low

  * New upstream release

 -- Enrico Tassi <gareuselesinge@debian.org>  Sat, 25 Oct 2008 18:38:54 +0200

lua-curl (0.2.1-3) unstable; urgency=low

  * Renamed cdbs deprecated variable 
  * Bumped standards versions
  * Added Homepage control field
  * Fixed package description
  * Updated Vcs-* fields
  * Moved -dev package to  Section libdevel
  * Commented test.dpatch to make lintian happy

 -- Enrico Tassi <gareuselesinge@debian.org>  Sat, 22 Mar 2008 21:24:05 +0100

lua-curl (0.2.1-2) unstable; urgency=low

  * Made control file binNMU safe

 -- Enrico Tassi <gareuselesinge@debian.org>  Sun, 13 May 2007 21:06:39 +0200

lua-curl (0.2.1-1) unstable; urgency=low

  * New upstream release that fixes large file support (Closes: #410360)
  * Added a note about the documentation shipped within the -dev package
    in the control file (Closes: #410005)
  * Added conmpilation flags for large file support
  * Added call to `lua5.1-policy-apply -r` to the clean:: hook

 -- Enrico Tassi <gareuselesinge@debian.org>  Thu, 15 Feb 2007 17:11:54 +0100

lua-curl (0.2.0-4) unstable; urgency=low

  * Moved to lua5.1-policy version 7

 -- Enrico Tassi <gareuselesinge@debian.org>  Fri, 13 Oct 2006 13:31:59 +0200

lua-curl (0.2.0-3) unstable; urgency=low

  * added XS-X-Vcs-svn field to control file.

 -- Enrico Tassi <gareuselesinge@debian.org>  Sun, 10 Sep 2006 14:44:40 +0200

lua-curl (0.2.0-2) unstable; urgency=low

  * Fixed a typo in the package description.

 -- Enrico Tassi <gareuselesinge@debian.org>  Sun, 10 Sep 2006 14:33:47 +0200

lua-curl (0.2.0-1) unstable; urgency=low

  * Initial release. (Closes: #383798)

 -- Enrico Tassi <gareuselesinge@debian.org>  Thu, 17 Aug 2006 20:15:23 +0200

=== debian/control ===
Source: lua-curl
Section: interpreters
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: debhelper (>= 8.1.3), libcurl4-gnutls-dev (>= 7.52.1-1~), dh-lua
Standards-Version: 3.9.3
Vcs-Git: https://salsa.debian.org/lua-team/lua-curl.git
Vcs-Browser: https://salsa.debian.org/lua-team/lua-curl

Package: lua-curl
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: ${lua:Provides}
XB-Lua-Versions: ${lua:Versions}
Description: libcURL bindings for the Lua language
 This package contains the bindings for the cURL library.
 Currently many different implementations of cURL bindings are available,
 this package includes the one developed for the FreePOPs project
 (see <http://www.freepops.org>).

Package: lua-curl-dev
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Section: libdevel
Depends: lua-curl (= ${binary:Version}), ${misc:Depends}
Provides: ${lua:Provides}
XB-Lua-Versions: ${lua:Versions}
Description: libcURL development files for the Lua language
 This package contains the development files of the libcURL Lua bindings,
 useful to create a statically linked binary (like a C application or a
 standalone Lua interpreter).
 .
 Documentation is also shipped within this package.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=lua --with lua

override_dh_auto_clean:
	$(MAKE) -f Makefile clean
	dh_auto_clean

override_dh_auto_configure:
	$(MAKE) -f Makefile HEADER="/usr/include/$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)/curl/curl.h" constants
	dh_auto_configure

=== debian/watch ===
# test this watch file using:
# uscan --watchfile debian/watch --upstream-version 0.0.1 --package luacurl
#
version=3
http://luaforge.net/frs/?group_id=117 \
	/frs/download.php/\d+/freepops-luacurl-source-([\d\.]*).tgz
